#include "string.h"


String::String()
{
	this->str = NULL;
}

String::String(char *str)
{
	this->str = NULL;
	SetString(str);
}

String::String(wchar *str)
{
	this->str = NULL;
	SetString(str);
}

String::~String()
{
	delete str;
}

void String::SetString(wchar *str)
{
	delete this->str;	
	this->str = wcsdup(str);
}

void String::SetString(char *str)
{
	delete this->str;
	int strLen = (int)strlen(str);
	this->str = new wchar[strLen + 1];
	MultiByteToWideChar(CP_ACP, 0, str, strLen + 1, this->str, strLen + 1);
}

String &String::operator = (String &str)
{
	SetString(str.GetString());
	return *this;
}

String &String::operator = (wchar *str)
{
	SetString(str);
	return *this;
}

String &String::operator = (char *str)
{
	SetString(str);
	return *this;
}
