#include "table.h"

HashTable::HashTable()
{
	for (int i = 0; i < 256; i++)
	{
		hash[i] = 0;
		ids[i] = 0;
	}
}

HashTable::~HashTable()
{
	for (int i = 0; i < 256; i++)
		if (hash[i])
			delete hash[i];
}

void HashTable::Add(char *word, int id)
{
	byte ch = *word++;
	byte nextch = *word;
	if (nextch)
	{
		if (!hash[ch])
			hash[ch] = new HashTable();
		hash[ch]->Add(word, id);
	}
	else
		ids[ch] = id;
}

bool HashTable::Find(char *word, int *id)
{
	byte ch = *word++;
	byte nextch = *word;
	if (nextch)
		if (hash[ch])
			return hash[ch]->Find(word, id);
		else
			return false;
	else if (ids[ch])
	{	
		*id = ids[ch];
		return true;
	}
	else
		return false;
}

bool HashTable::FindById(int id, char *word)
{
	for (int i = 0; i < 256; i++)
		if (ids[i] = id)
		{
			*word++ = (byte)i;
			*word = '\0';
			return true;
		}

	for (int i = 0; i < 256; i++)
		if (hash[i])
			if (hash[i]->FindById(id, word++))
			{
				*word = (byte)i;
				return true;
			}

	return false;
}
