/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   dialog.h                                                                  *
*       Win API                                             *
*                                                                             *
*******************************************************************************/


#ifndef DIALOG_H
#define DIALOG_H

#include "types.h"


const wchar stFloatEditFormat[] = L"%0.3f";

void SetControlText(HWND hwnd, int id, wchar *str);
void GetControlText(HWND hwnd, int id, wchar *str, int maxCount);

void SetEditValue(HWND hwnd, int id, REAL value);
void GetEditValue(HWND hwnd, int id, REAL *value, REAL min, REAL max, REAL def);

void SetCheckBoxState(HWND hwnd, int id, bool state);
void GetCheckBoxState(HWND hwnd, int id, bool *state);

void ComboBoxAdd(HWND hwnd, int id, int index, wchar *str);
int GetComboBoxCurrSel(HWND hwnd, int id);
void SetComboBoxCurrSel(HWND hwnd, int id, int index);


#endif
