/******************************************************************************
*                                                                             *
*                                                    *
*                                                     *
*                                                                             *
*   15  2004 .                                                        *
*   (C)                                                         *
*   e-mail       pavelkok@mail.ru                                             *
*   home page    http://kps.nm.ru                                             *
*                                                                             *
*                                                                             *
*   dlg_texture.h                                                             *
*       Win API                                             *
*                                                                             *
*******************************************************************************/


#ifndef DLG_TEXTURE_H
#define DLG_TEXTURE_H


#include "types.h"
#include "scene.h"
#include "resource.h"


const int childDlgX = 0;
const int childDlgY = 160;
const int childDlgCX = 330;
const int childDlgCY = 270;


extern Scene *scene;
extern HINSTANCE hInstance;
extern Texture **editTexture;


int CALLBACK TextureBitmapDialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
int CALLBACK TextureCheckerDialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
int CALLBACK TexturePerlinNoiseDialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

int CALLBACK TextureDialogProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);


const int DlgTextureInfoCount = 4;

struct DlgTextureInfo
{
	int id;
	DLGPROC proc;
	wchar *typeName;
};

extern DlgTextureInfo texInfo[DlgTextureInfoCount];


#endif
