#ifndef IMPT_ASE_IDS_H
#define IMPT_ASE_IDS_H


enum TokenASE
{
	ID_NONE = 0, 
	ID_NUM = 10, 
	ID_STRING = 20, 
	ID_LCURVE = 30, 
	ID_RCURVE = 31, 
	ID_COLON = 32, 
	ID_SEMI = 33, 

	ID_SCENE = 100, 
	ID_GEOMETRY, 
	ID_SHAPE, 
	ID_CAMERA, 
	ID_LIGHT, 
	ID_HELPER, 
	ID_MATERIAL_LIST, 
	ID_GROUP, 
	ID_NODE_TM, 
	ID_NODE_NAME, 
	ID_NODE_PARENT, 
	ID_PROP_MOTIONBLUR, 
	ID_PROP_CASTSHADOW, 
	ID_PROP_RECVSHADOW, 
	ID_MESH, 
	ID_MESH_NORMALS, 
	ID_MESH_NUMVERTEX, 
	ID_MESH_NUMFACES, 
	ID_MESH_VERTEX_LIST, 
	ID_MESH_VERTEX, 
	ID_MESH_FACE_LIST, 
	ID_MESH_FACE, 
	ID_MESH_FACE_A,
	ID_MESH_FACE_B,
	ID_MESH_FACE_C,
	ID_MESH_FACE_AB,
	ID_MESH_FACE_BC,
	ID_MESH_FACE_CA,
	ID_MESH_SMOOTHING, 
	ID_MESH_MTLID, 
	ID_MESH_NUMTVERTEX, 
	ID_MESH_NUMTVFACES, 
	ID_MESH_TVERTLIST, 
	ID_MESH_TVERT, 
	ID_MESH_TFACELIST, 
	ID_MESH_TFACE, 
	ID_MESH_NUMCVERTEX, 
	ID_MESH_NUMCVFACES, 
	ID_MESH_CVERTLIST, 
	ID_MESH_VERTCOL, 
	ID_MESH_CFACELIST, 
	ID_MESH_CFACE, 
	ID_MESH_FACEMAPLIST, 
	ID_MESH_FACEMAP, 
	ID_MESH_FACEVERT, 
	ID_MESH_FACENORMAL, 
	ID_MESH_VERTEXNORMAL, 
	ID_MESH_ANIMATION, 
	ID_SHAPE_LINECOUNT, 
	ID_SHAPE_LINE, 
	ID_SHAPE_VERTEX_KNOT, 
	ID_SHAPE_VERTEX_INTERP, 
	ID_SHAPE_VERTEXCOUNT, 
	ID_SHAPE_CLOSED, 
	ID_LIGHT_SETTINGS, 
	ID_LIGHT_TYPE, 
	ID_LIGHT_COLOR, 
	ID_LIGHT_INTENS, 
	ID_LIGHT_HOTSPOT, 
	ID_LIGHT_FALLOFF, 
	ID_LIGHT_ATTNSTART, 
	ID_LIGHT_ATTNEND, 
	ID_LIGHT_ASPECT, 
	ID_LIGHT_SHADOWS, 
	ID_LIGHT_USELIGHT, 
	ID_LIGHT_SPOTSHAPE, 
	ID_LIGHT_TDIST, 
	ID_LIGHT_MAPBIAS, 
	ID_LIGHT_MAPRANGE, 
	ID_LIGHT_MAPSIZE, 
	ID_LIGHT_RAYBIAS, 
	ID_LIGHT_USEGLOBAL, 
	ID_LIGHT_ABSMAPBIAS, 
	ID_LIGHT_OVERSHOOT, 
	ID_LIGHT_EXCLUSIONLIST, 
	ID_LIGHT_NUMEXCLUDED, 
	ID_LIGHT_EXCLUDED, 
	ID_LIGHT_EXCLINCLUDE, 
	ID_LIGHT_EXCL_AFFECT_ILLUM, 
	ID_LIGHT_EXCL_AFFECT_SHAD, 
	ID_LIGHT_ANIMATION, 
	ID_LIGHT_TYPE_OMNI, 
	ID_LIGHT_TYPE_TARG, 
	ID_LIGHT_TYPE_DIR, 
	ID_LIGHT_TYPE_FREE, 
	ID_LIGHT_SHAD_OFF, 
	ID_LIGHT_SHAD_MAP, 
	ID_LIGHT_SHAD_RAY, 
	ID_LIGHT_SHAPE_CIRC, 
	ID_LIGHT_SHAPE_RECT, 
	ID_CAMERA_SETTINGS, 
	ID_CAMERA_HITHER, 
	ID_CAMERA_YON, 
	ID_CAMERA_NEAR, 
	ID_CAMERA_FAR, 
	ID_CAMERA_FOV, 
	ID_CAMERA_TDIST, 
	ID_CAMERA_ANIMATION, 
	ID_CAMERA_TYPE, 
	ID_CAMERATYPE_TARGET, 
	ID_CAMERATYPE_FREE, 
	ID_HELPER_CLASS, 
	ID_CONTROL_POINT3_TCB, 
	ID_CONTROL_POINT3_BEZIER, 
	ID_CONTROL_COLOR_BEZIER, 
	ID_CONTROL_POINT3_SAMPLE, 
	ID_CONTROL_FLOAT_TCB, 
	ID_CONTROL_FLOAT_BEZIER, 
	ID_CONTROL_FLOAT_LINEAR, 
	ID_CONTROL_FLOAT_SAMPLE, 
	ID_POS_TRACK, 
	ID_ROT_TRACK, 
	ID_SCALE_TRACK, 
	ID_POS_SAMPLE, 
	ID_ROT_SAMPLE, 
	ID_SCALE_SAMPLE, 
	ID_POS_KEY, 
	ID_ROT_KEY, 
	ID_SCALE_KEY, 
	ID_POINT3_KEY, 
	ID_FLOAT_KEY, 
	ID_TCB_POINT3_KEY, 
	ID_TCB_FLOAT_KEY, 
	ID_TCB_POS_KEY, 
	ID_TCB_ROT_KEY, 
	ID_TCB_SCALE_KEY, 
	ID_BEZIER_FLOAT_KEY, 
	ID_BEZIER_POINT3_KEY, 
	ID_BEZIER_POS_KEY, 
	ID_BEZIER_SCALE_KEY, 
	ID_CONTROL_POS_LINEAR, 
	ID_CONTROL_POS_TCB, 
	ID_CONTROL_POS_BEZIER, 
	ID_CONTROL_ROT_LINEAR, 
	ID_CONTROL_ROT_TCB, 
	ID_CONTROL_ROT_BEZIER, 
	ID_CONTROL_SCALE_LINEAR , 
	ID_CONTROL_SCALE_TCB, 
	ID_CONTROL_SCALE_BEZIER, 
	ID_IKTERMINATOR, 
	ID_IKROT_PINNED, 
	ID_IKPOS_PINNED, 
	ID_IKJOINT, 
	ID_IKTYPE, 
	ID_IKDOF, 
	ID_IKXACTIVE, 
	ID_IKYACTIVE, 
	ID_IKZACTIVE, 
	ID_IKXLIMITED, 
	ID_IKYLIMITED, 
	ID_IKZLIMITED, 
	ID_IKXEASE, 
	ID_IKYEASE, 
	ID_IKZEASE, 
	ID_IKLIMITEXACT, 
	ID_IKJOINTINFO, 
	ID_IKTYPEPOS, 
	ID_IKTYPEROT, 
	ID_WIRECOLOR, 
	ID_MATERIAL, 
	ID_MATERIAL_COUNT, 
	ID_MATERIAL_REF, 
	ID_NUMSUBMTLS, 
	ID_SUBMATERIAL, 
	ID_MATNAME, 
	ID_MATCLASS, 
	ID_MAT_SHADE_CONST, 
	ID_MAT_SHADE_PHONG, 
	ID_MAT_SHADE_METAL, 
	ID_MAT_SHADE_BLINN, 
	ID_MAT_SHADE_OTHER, 
	ID_MAP_XPTYPE_FLT, 
	ID_MAP_XPTYPE_SUB, 
	ID_MAP_XPTYPE_ADD, 
	ID_MAP_XPTYPE_OTH, 
	ID_BMP_FILT_PYR, 
	ID_BMP_FILT_SAT, 
	ID_BMP_FILT_NONE, 
	ID_FALLOFF_OUT, 
	ID_FALLOFF_IN, 
	ID_MAPTYPE_EXP, 
	ID_MAPTYPE_SPH, 
	ID_MAPTYPE_CYL, 
	ID_MAPTYPE_SHR, 
	ID_MAPTYPE_SCR, 
	ID_AMBIENT, 
	ID_DIFFUSE, 
	ID_SPECULAR, 
	ID_SHINE, 
	ID_SHINE_STRENGTH, 
	ID_TRANSPARENCY, 
	ID_WIRESIZE, 
	ID_SHADING, 
	ID_XP_FALLOFF, 
	ID_SELFILLUM, 
	ID_TWOSIDED, 
	ID_WIRE, 
	ID_WIREUNITS, 
	ID_FALLOFF, 
	ID_FACEMAP, 
	ID_SOFTEN, 
	ID_XP_TYPE, 
	ID_TEXNAME, 
	ID_TEXCLASS, 
	ID_TEXSUBNO, 
	ID_TEXAMOUNT, 
	ID_BITMAP, 
	ID_TEX_INVERT, 
	ID_BMP_FILTER, 
	ID_MAPTYPE, 
	ID_U_OFFSET, 
	ID_V_OFFSET, 
	ID_U_TILING, 
	ID_V_TILING, 
	ID_ANGLE, 
	ID_BLUR, 
	ID_BLUR_OFFSET, 
	ID_NOISE_AMT, 
	ID_NOISE_SIZE, 
	ID_NOISE_LEVEL, 
	ID_NOISE_PHASE, 
	ID_MAP_GENERIC, 
	ID_MAP_AMBIENT, 
	ID_MAP_DIFFUSE, 
	ID_MAP_SPECULAR, 
	ID_MAP_SHINE, 
	ID_MAP_SHINESTRENGTH, 
	ID_MAP_SELFILLUM, 
	ID_MAP_OPACITY, 
	ID_MAP_FILTERCOLOR, 
	ID_MAP_BUMP, 
	ID_MAP_REFLECT, 
	ID_MAP_REFRACT, 
	ID_TM_ROW0, 
	ID_TM_ROW1, 
	ID_TM_ROW2, 
	ID_TM_ROW3, 
	ID_TM_POS, 
	ID_TM_ROTAXIS, 
	ID_TM_ROTANGLE, 
	ID_TM_SCALE, 
	ID_TM_SCALEAXIS, 
	ID_TM_SCALEAXISANG, 
	ID_TM_ANIMATION, 
	ID_INHERIT_POS, 
	ID_INHERIT_ROT, 
	ID_INHERIT_SCL, 
	ID_FILENAME, 
	ID_FIRSTFRAME, 
	ID_LASTFRAME, 
	ID_FRAMESPEED, 
	ID_TICKSPERFRAME, 
	ID_ENVMAP, 
	ID_STATICBGCOLOR, 
	ID_ANIMBGCOLOR, 
	ID_STATICAMBIENT, 
	ID_ANIMAMBIENT, 
	ID_VISIBILITY_TRACK, 
	ID_TIMEVALUE, 
	ID_COMMENT, 
	ID_FILEID, 
	ID_BOUNDINGBOX_MIN, 
	ID_BOUNDINGBOX_MAX
};


// Top level category ID's
#define ST_SCENE						"*SCENE"
#define ST_GEOMETRY						"*GEOMOBJECT" 
#define ST_SHAPE						"*SHAPEOBJECT" 
#define ST_CAMERA						"*CAMERAOBJECT" 
#define ST_LIGHT						"*LIGHTOBJECT" 
#define ST_HELPER						"*HELPEROBJECT"
#define ST_MATERIAL_LIST				"*MATERIAL_LIST"

// Hierarchy
#define ST_GROUP						"*GROUP"

// Node related ID's
#define ST_NODE_TM						"*NODE_TM"
#define ST_NODE_NAME					"*NODE_NAME" 
#define ST_NODE_PARENT					"*NODE_PARENT"

// Object node properties
#define ST_PROP_MOTIONBLUR				"*PROP_MOTIONBLUR"
#define ST_PROP_CASTSHADOW				"*PROP_CASTSHADOW"
#define ST_PROP_RECVSHADOW				"*PROP_RECVSHADOW"

// Mesh related ID's
#define ST_MESH							"*MESH"
#define ST_MESH_NORMALS					"*MESH_NORMALS" 
#define ST_MESH_NUMVERTEX				"*MESH_NUMVERTEX" 
#define ST_MESH_NUMFACES				"*MESH_NUMFACES" 
#define ST_MESH_VERTEX_LIST				"*MESH_VERTEX_LIST" 
#define ST_MESH_VERTEX					"*MESH_VERTEX"
#define ST_MESH_FACE_LIST				"*MESH_FACE_LIST" 
#define ST_MESH_FACE					"*MESH_FACE"
#define ST_MESH_FACE_A					"A"
#define ST_MESH_FACE_B					"B"
#define ST_MESH_FACE_C					"C"
#define ST_MESH_FACE_AB					"AB"
#define ST_MESH_FACE_BC					"BC"
#define ST_MESH_FACE_CA					"CA"
#define ST_MESH_SMOOTHING				"*MESH_SMOOTHING" 
#define ST_MESH_MTLID					"*MESH_MTLID"

#define ST_MESH_NUMTVERTEX				"*MESH_NUMTVERTEX" 
#define ST_MESH_NUMTVFACES				"*MESH_NUMTVFACES" 
#define ST_MESH_TVERTLIST				"*MESH_TVERTLIST" 
#define ST_MESH_TVERT					"*MESH_TVERT" 
#define ST_MESH_TFACELIST				"*MESH_TFACELIST" 
#define ST_MESH_TFACE					"*MESH_TFACE"

#define ST_MESH_NUMCVERTEX				"*MESH_NUMCVERTEX"
#define ST_MESH_NUMCVFACES				"*MESH_NUMCVFACES" 
#define ST_MESH_CVERTLIST				"*MESH_CVERTLIST"
#define ST_MESH_VERTCOL					"*MESH_VERTCOL"
#define ST_MESH_CFACELIST				"*MESH_CFACELIST"
#define ST_MESH_CFACE					"*MESH_CFACE"


#define ST_MESH_FACEMAPLIST				"*MESH_FACEMAPLIST" 
#define ST_MESH_FACEMAP					"*MESH_FACEMAP" 
#define ST_MESH_FACEVERT				"*MESH_FACEMAPVERT"

#define ST_MESH_FACENORMAL				"*MESH_FACENORMAL" 
#define ST_MESH_VERTEXNORMAL			"*MESH_VERTEXNORMAL"

#define ST_MESH_ANIMATION				"*MESH_ANIMATION"

// Shape ID's
#define ST_SHAPE_LINECOUNT				"*SHAPE_LINECOUNT" 
#define ST_SHAPE_LINE					"*SHAPE_LINE"
#define ST_SHAPE_VERTEX_KNOT			"*SHAPE_VERTEX_KNOT" 
#define ST_SHAPE_VERTEX_INTERP			"*SHAPE_VERTEX_INTERP" 
#define ST_SHAPE_VERTEXCOUNT			"*SHAPE_VERTEXCOUNT" 
#define ST_SHAPE_CLOSED					"*SHAPE_CLOSED"

// Light ID's
#define ST_LIGHT_SETTINGS				"*LIGHT_SETTINGS" 
#define ST_LIGHT_TYPE					"*LIGHT_TYPE" 
#define ST_LIGHT_COLOR					"*LIGHT_COLOR" 
#define ST_LIGHT_INTENS					"*LIGHT_INTENS" 
#define ST_LIGHT_HOTSPOT				"*LIGHT_HOTSPOT" 
#define ST_LIGHT_FALLOFF				"*LIGHT_FALLOFF" 
#define ST_LIGHT_ATTNSTART				"*LIGHT_ATTNSTART" 
#define ST_LIGHT_ATTNEND				"*LIGHT_ATTNEND"
#define ST_LIGHT_ASPECT					"*LIGHT_ASPECT"
#define ST_LIGHT_SHADOWS				"*LIGHT_SHADOWS"
#define ST_LIGHT_USELIGHT				"*LIGHT_USELIGHT"
#define ST_LIGHT_SPOTSHAPE				"*LIGHT_SPOTSHAPE"
#define ST_LIGHT_TDIST					"*LIGHT_TDIST"
#define ST_LIGHT_MAPBIAS				"*LIGHT_MAPBIAS"
#define ST_LIGHT_MAPRANGE				"*LIGHT_MAPRANGE"
#define ST_LIGHT_MAPSIZE				"*LIGHT_MAPSIZE"
#define ST_LIGHT_RAYBIAS				"*LIGHT_RAYBIAS"
#define ST_LIGHT_USEGLOBAL				"*LIGHT_USEGLOBAL"
#define ST_LIGHT_ABSMAPBIAS				"*LIGHT_ABSMAPBIAS"
#define ST_LIGHT_OVERSHOOT				"*LIGHT_OVERSHOOT"
#define ST_LIGHT_EXCLUSIONLIST			"*LIGHT_EXCLUDELIST"
#define ST_LIGHT_NUMEXCLUDED			"*LIGHT_NUMEXCLUDED"
#define ST_LIGHT_EXCLUDED				"*LIGHT_EXCLUDED"
#define ST_LIGHT_EXCLINCLUDE			"*LIGHT_EXCLUDED_INCLUDE"
#define ST_LIGHT_EXCL_AFFECT_ILLUM		"*LIGHT_EXCLUDED_AFFECT_ILLUM"
#define ST_LIGHT_EXCL_AFFECT_SHAD		"*LIGHT_EXCLUDED_AFFECT_SHADOW"
#define ST_LIGHT_ANIMATION				"*LIGHT_ANIMATION"

#define ST_LIGHT_TYPE_OMNI				"Omni"
#define ST_LIGHT_TYPE_TARG				"Target"
#define ST_LIGHT_TYPE_DIR				"Directional"
#define ST_LIGHT_TYPE_FREE				"Free"

#define ST_LIGHT_SHAD_OFF				"Off"
#define ST_LIGHT_SHAD_MAP				"Mapped"
#define ST_LIGHT_SHAD_RAY				"Raytraced"

#define ST_LIGHT_SHAPE_CIRC				"Circle"
#define ST_LIGHT_SHAPE_RECT				"Rect"

// Camera ID's
#define ST_CAMERA_SETTINGS				"*CAMERA_SETTINGS"
#define ST_CAMERA_HITHER				"*CAMERA_HITHER" 
#define ST_CAMERA_YON					"*CAMERA_YON" 
#define ST_CAMERA_NEAR					"*CAMERA_NEAR" 
#define ST_CAMERA_FAR					"*CAMERA_FAR" 
#define ST_CAMERA_FOV					"*CAMERA_FOV" 
#define ST_CAMERA_TDIST					"*CAMERA_TDIST"
#define ST_CAMERA_ANIMATION				"*CAMERA_ANIMATION"

#define ST_CAMERA_TYPE					"*CAMERA_TYPE"
#define ST_CAMERATYPE_TARGET			"Target"
#define ST_CAMERATYPE_FREE				"Free"

// Helper objects
#define ST_HELPER_CLASS					"*HELPER_CLASS"

// Controller ID's
#define ST_CONTROL_POINT3_TCB			"*CONTROL_POINT3_TCB" 
#define ST_CONTROL_POINT3_BEZIER		"*CONTROL_POINT3_BEZIER" 
#define ST_CONTROL_COLOR_BEZIER			"*CONTROL_COLOR_BEZIER" 
#define ST_CONTROL_POINT3_SAMPLE		"*CONTROL_POINT3_SAMPLE"

#define ST_CONTROL_FLOAT_TCB			"*CONTROL_FLOAT_TCB" 
#define ST_CONTROL_FLOAT_BEZIER			"*CONTROL_FLOAT_BEZIER" 
#define ST_CONTROL_FLOAT_LINEAR			"*CONTROL_FLOAT_LINEAR" 
#define ST_CONTROL_FLOAT_SAMPLE			"*CONTROL_FLOAT_SAMPLE"

// "Track" is the identification of a sampled controller
#define ST_POS_TRACK					"*CONTROL_POS_TRACK"
#define ST_ROT_TRACK					"*CONTROL_ROT_TRACK" 
#define ST_SCALE_TRACK					"*CONTROL_SCALE_TRACK"

// Sampled keys
#define ST_POS_SAMPLE					"*CONTROL_POS_SAMPLE"
#define ST_ROT_SAMPLE					"*CONTROL_ROT_SAMPLE" 
#define ST_SCALE_SAMPLE					"*CONTROL_SCALE_SAMPLE"

// Specific controller keys
#define ST_POS_KEY						"*CONTROL_POS_KEY"
#define ST_ROT_KEY						"*CONTROL_ROT_KEY" 
#define ST_SCALE_KEY					"*CONTROL_SCALE_KEY"
#define ST_POINT3_KEY					"*CONTROL_POINT3_KEY"
#define ST_FLOAT_KEY					"*CONTROL_FLOAT_KEY"

// TCB Keys have Tens, cont, bias, easeIn, easeOut
#define ST_TCB_POINT3_KEY				"*CONTROL_TCB_POINT3_KEY"
#define ST_TCB_FLOAT_KEY				"*CONTROL_TCB_FLOAT_KEY"
#define ST_TCB_POS_KEY					"*CONTROL_TCB_POS_KEY"
#define ST_TCB_ROT_KEY					"*CONTROL_TCB_ROT_KEY" 
#define ST_TCB_SCALE_KEY				"*CONTROL_TCB_SCALE_KEY"

// Bezier keys have inTan, outTan
#define ST_BEZIER_FLOAT_KEY				"*CONTROL_BEZIER_FLOAT_KEY"
#define ST_BEZIER_POINT3_KEY			"*CONTROL_BEZIER_POINT3_KEY"
#define ST_BEZIER_POS_KEY				"*CONTROL_BEZIER_POS_KEY"
#define ST_BEZIER_SCALE_KEY				"*CONTROL_BEZIER_SCALE_KEY"


#define ST_CONTROL_POS_LINEAR			"*CONTROL_POS_LINEAR"
#define ST_CONTROL_POS_TCB				"*CONTROL_POS_TCB"
#define ST_CONTROL_POS_BEZIER			"*CONTROL_POS_BEZIER"
#define ST_CONTROL_ROT_LINEAR			"*CONTROL_ROT_LINEAR"
#define ST_CONTROL_ROT_TCB				"*CONTROL_ROT_TCB"
#define ST_CONTROL_ROT_BEZIER			"*CONTROL_ROT_BEZIER"
#define ST_CONTROL_SCALE_LINEAR 		"*CONTROL_SCALE_LINEAR"
#define ST_CONTROL_SCALE_TCB			"*CONTROL_SCALE_TCB"
#define ST_CONTROL_SCALE_BEZIER			"*CONTROL_SCALE_BEZIER"


// IK Node Info
#define ST_IKTERMINATOR					"*IK_TERMINATOR"
#define ST_IKROT_PINNED					"*IK_ROT_PINNED"
#define ST_IKPOS_PINNED					"*IK_POS_PINNED"

// IK Joints
#define ST_IKJOINT						"*IK_JOINT"
#define ST_IKTYPE						"*IK_TYPE"
#define ST_IKDOF						"*IK_DOF"
#define ST_IKXACTIVE					"*IK_XACTIVE"
#define ST_IKYACTIVE					"*IK_YACTIVE"
#define ST_IKZACTIVE					"*IK_ZACTIVE"
#define ST_IKXLIMITED					"*IK_XLIMITED"
#define ST_IKYLIMITED					"*IK_YLIMITED"
#define ST_IKZLIMITED					"*IK_ZLIMITED"
#define ST_IKXEASE						"*IK_XEASE"
#define ST_IKYEASE						"*IK_YEASE"
#define ST_IKZEASE						"*IK_ZEASE"
#define ST_IKLIMITEXACT					"*IK_LIMITEXACT"
#define ST_IKJOINTINFO					"*IK_JOINTINFO"
#define ST_IKTYPEPOS					"Position"
#define ST_IKTYPEROT					"Rotation"

// Material / Texture related ID's
#define ST_WIRECOLOR					"*WIREFRAME_COLOR" 
#define ST_MATERIAL						"*MATERIAL" 
#define ST_MATERIAL_COUNT				"*MATERIAL_COUNT" 
#define ST_MATERIAL_REF					"*MATERIAL_REF"
#define ST_NUMSUBMTLS					"*NUMSUBMTLS" 
#define ST_SUBMATERIAL					"*SUBMATERIAL" 
#define ST_MATNAME						"*MATERIAL_NAME" 
#define ST_MATCLASS						"*MATERIAL_CLASS"

#define ST_MAT_SHADE_CONST				"Constant"
#define ST_MAT_SHADE_PHONG				"Phong"
#define ST_MAT_SHADE_METAL				"Metal"
#define ST_MAT_SHADE_BLINN				"Blinn"
#define ST_MAT_SHADE_OTHER				"Other"

#define ST_MAP_XPTYPE_FLT				"Filter"
#define ST_MAP_XPTYPE_SUB				"Subtractive"
#define ST_MAP_XPTYPE_ADD				"Additive"
#define ST_MAP_XPTYPE_OTH				"Other"

#define ST_BMP_FILT_PYR					"Pyramidal"
#define ST_BMP_FILT_SAT					"SAT"
#define ST_BMP_FILT_NONE				"None"

#define ST_FALLOFF_OUT					"Out"
#define ST_FALLOFF_IN					"In"
								
#define ST_MAPTYPE_EXP					"Explicit"
#define ST_MAPTYPE_SPH					"Spherical"
#define ST_MAPTYPE_CYL					"Cylindrical"
#define ST_MAPTYPE_SHR					"Shrinkwrap"
#define ST_MAPTYPE_SCR					"Screen"
								
#define ST_AMBIENT						"*MATERIAL_AMBIENT" 
#define ST_DIFFUSE						"*MATERIAL_DIFFUSE" 
#define ST_SPECULAR						"*MATERIAL_SPECULAR" 
#define ST_SHINE						"*MATERIAL_SHINE"
#define ST_SHINE_STRENGTH				"*MATERIAL_SHINESTRENGTH" 
#define ST_TRANSPARENCY					"*MATERIAL_TRANSPARENCY" 
#define ST_WIRESIZE						"*MATERIAL_WIRESIZE"
								
#define ST_SHADING						"*MATERIAL_SHADING" 
#define ST_XP_FALLOFF					"*MATERIAL_XP_FALLOFF" 
#define ST_SELFILLUM					"*MATERIAL_SELFILLUM" 
#define ST_TWOSIDED						"*MATERIAL_TWOSIDED" 
#define ST_WIRE							"*MATERIAL_WIRE"
#define ST_WIREUNITS					"*MATERIAL_WIREUNITS" 
#define ST_FALLOFF						"*MATERIAL_FALLOFF" 
#define ST_FACEMAP						"*MATERIAL_FACEMAP" 
#define ST_SOFTEN						"*MATERIAL_SOFTEN" 
#define ST_XP_TYPE						"*MATERIAL_XP_TYPE"
								
#define ST_TEXNAME						"*MAP_NAME" 
#define ST_TEXCLASS						"*MAP_CLASS" 
#define ST_TEXSUBNO						"*MAP_SUBNO" 
#define ST_TEXAMOUNT					"*MAP_AMOUNT"
								
#define ST_BITMAP						"*BITMAP"
#define ST_TEX_INVERT					"*BITMAP_INVERT" 
#define ST_BMP_FILTER					"*BITMAP_FILTER"
								
#define ST_MAPTYPE						"*MAP_TYPE" 
#define ST_U_OFFSET						"*UVW_U_OFFSET" 
#define ST_V_OFFSET						"*UVW_V_OFFSET" 
#define ST_U_TILING						"*UVW_U_TILING" 
#define ST_V_TILING						"*UVW_V_TILING" 
#define ST_ANGLE						"*UVW_ANGLE" 
#define ST_BLUR							"*UVW_BLUR"
#define ST_BLUR_OFFSET					"*UVW_BLUR_OFFSET" 
#define ST_NOISE_AMT					"*UVW_NOUSE_AMT" 
#define ST_NOISE_SIZE					"*UVW_NOISE_SIZE" 
#define ST_NOISE_LEVEL					"*UVW_NOISE_LEVEL" 
#define ST_NOISE_PHASE					"*UVW_NOISE_PHASE"
								
// Sub texture types			
#define ST_MAP_GENERIC					"*MAP_GENERIC" 
#define ST_MAP_AMBIENT					"*MAP_AMBIENT" 
#define ST_MAP_DIFFUSE					"*MAP_DIFFUSE" 
#define ST_MAP_SPECULAR					"*MAP_SPECULAR" 
#define ST_MAP_SHINE					"*MAP_SHINE"
#define ST_MAP_SHINESTRENGTH			"*MAP_SHINESTRENGTH" 
#define ST_MAP_SELFILLUM				"*MAP_SELFILLUM" 
#define ST_MAP_OPACITY					"*MAP_OPACITY"
#define ST_MAP_FILTERCOLOR				"*MAP_FILTERCOLOR" 
#define ST_MAP_BUMP						"*MAP_BUMP"
#define ST_MAP_REFLECT					"*MAP_REFLECT" 
#define ST_MAP_REFRACT					"*MAP_REFRACT"
								
// TM related ID's				
#define ST_TM_ROW0						"*TM_ROW0" 
#define ST_TM_ROW1						"*TM_ROW1" 
#define ST_TM_ROW2						"*TM_ROW2" 
#define ST_TM_ROW3						"*TM_ROW3" 
#define ST_TM_POS						"*TM_POS"
#define ST_TM_ROTAXIS					"*TM_ROTAXIS" 
#define ST_TM_ROTANGLE					"*TM_ROTANGLE" 
#define ST_TM_SCALE						"*TM_SCALE" 
#define ST_TM_SCALEAXIS					"*TM_SCALEAXIS"
#define ST_TM_SCALEAXISANG				"*TM_SCALEAXISANG" 
#define ST_TM_ANIMATION					"*TM_ANIMATION"

// TM Inheritance flags
#define ST_INHERIT_POS					"*INHERIT_POS"
#define ST_INHERIT_ROT					"*INHERIT_ROT"
#define ST_INHERIT_SCL					"*INHERIT_SCL"

// Scene related ID's			
#define ST_FILENAME						"*SCENE_FILENAME" 
#define ST_FIRSTFRAME					"*SCENE_FIRSTFRAME" 
#define ST_LASTFRAME					"*SCENE_LASTFRAME" 
#define ST_FRAMESPEED					"*SCENE_FRAMESPEED" 
#define ST_TICKSPERFRAME				"*SCENE_TICKSPERFRAME" 
#define ST_ENVMAP						"*SCENE_ENVMAP"
#define ST_STATICBGCOLOR				"*SCENE_BACKGROUND_STATIC" 
#define ST_ANIMBGCOLOR					"*SCENE_BACKGROUND_ANIM" 
#define ST_STATICAMBIENT				"*SCENE_AMBIENT_STATIC" 
#define ST_ANIMAMBIENT					"*SCENE_AMBIENT_ANIM"

#define ST_VISIBILITY_TRACK				"*NODE_VISIBILITY_TRACK"

// Generic ID's that can show up here and there 
#define ST_TIMEVALUE					"*TIMEVALUE"
#define ST_COMMENT						"*COMMENT"
#define ST_FILEID						"*3DSMAX_ASCIIEXPORT"
#define ST_BOUNDINGBOX_MIN				"*BOUNDINGBOX_MIN"
#define ST_BOUNDINGBOX_MAX				"*BOUNDINGBOX_MAX"


#endif
